'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactUikitBase = require('react-uikit-base');

var _reactUikitBase2 = _interopRequireDefault(_reactUikitBase);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Button = (function (_React$Component) {
  _inherits(Button, _React$Component);

  function Button() {
    _classCallCheck(this, Button);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Button).apply(this, arguments));
  }

  _createClass(Button, [{
    key: 'render',
    value: function render() {
      var $props = this.props;

      // CSS classes
      var context = {
        primary: ' uk-button-primary',
        success: ' uk-button-success',
        danger: ' uk-button-danger',
        link: ' uk-button-link'
      };

      var size = {
        mini: ' uk-button-mini',
        small: ' uk-button-small',
        large: ' uk-button-large'
      };

      var cssClassNames = _reactUikitBase2.default.helpers.cleanClasses(['uk-button', $props.classes, $props.block ? 'uk-width-1-1' : null, $props.context ? context[$props.context] : null, $props.size ? size[$props.size] : null, $props.className]);

      // Elements
      var ignoreProps = ['type'];

      var type = {
        button: _react2.default.createElement(
          'button',
          _extends({}, _reactUikitBase2.default.helpers.cleanProps($props, ignoreProps), {
            className: cssClassNames,
            type: 'button',
            onClick: $props.onClick,
            disabled: $props.disabled,
            'data-kitid': $props.kitid
          }),
          $props.body,
          $props.children
        ),

        close: _react2.default.createElement('a', _extends({}, _reactUikitBase2.default.helpers.cleanProps($props, ignoreProps), {
          className: 'uk-close ' + cssClassNames,
          href: '#',
          onClick: $props.onClick,
          'data-kitid': $props.kitid
        })),

        link: _react2.default.createElement(
          'a',
          _extends({}, _reactUikitBase2.default.helpers.cleanProps($props, ignoreProps), {
            className: cssClassNames,
            href: '#',
            role: 'button',
            onClick: $props.onClick,
            'data-kitid': $props.kitid
          }),
          $props.body,
          $props.children
        )
      };

      // Return Component
      var button = type[$props.type] || type['button'];

      // const dropdown = ufunc.maybeIf(
      //   <div
      //   className="uk-button-dropdown"
      //   >
      //     {button}
      //
      //     <div className="uk-dropdown uk-dropdown-small">
      //         <ul className="uk-nav uk-nav-dropdown">
      //           {
      //             $props.dropdown.map((item, index) => {
      //               <li key={index}>
      //                 <a href=''></a>
      //               </li>;
      //             })
      //           }
      //         </ul>
      //     </div>
      //
      //   </div>
      // )($props.dropdown);

      // const component = ufunc.either(dropdown, button);

      return button;
    }
  }]);

  return Button;
})(_react2.default.Component);

Button.propTypes = {
  body: _react2.default.PropTypes.string,
  block: _react2.default.PropTypes.bool,
  dropdown: _react2.default.PropTypes.bool,
  context: _react2.default.PropTypes.oneOf(['primary', 'success', 'danger', 'link']),
  disabled: _react2.default.PropTypes.bool,
  size: _react2.default.PropTypes.oneOf(['mini', 'small', 'large']),
  type: _react2.default.PropTypes.oneOf(['button', 'close', 'link'])
};
exports.default = _reactUikitBase2.default.base(Button);